Loading...
Searching...
No Matches
DcmTLSCiphersuiteHandler Class Reference

This helper class manages the list of TLS ciphersuites supported by DCMTK, translates DcmTLSSecurityProfile enums into the corresponding sets of ciphersuites, and permits translation between the official TLS ciphersuite names (as used in DCMTK) and the corresponding internal OpenSSL name. More...

## Public Member Functions

| DcmTLSCiphersuiteHandler ()
| constructor.
virtual | ~DcmTLSCiphersuiteHandler ()
| destructor
OFCondition | setTLSProfile (DcmTLSSecurityProfile profile)
| replace the current list of ciphersuites by the list of ciphersuites for the given profile.
DcmTLSSecurityProfile | getTLSProfile () const
| return the currently selected TLS profile
void | clearTLSProfile ()
| clear the current list of ciphersuites.
OFCondition | addCipherSuite (const char *suite)
| adds a TLS 1.0-1.2 ciphersuite to the list of ciphersuites for TLS negotiation.
void | getListOfCipherSuitesForOpenSSL (OFString &cslist, OFBool isServer) const
| returns a string in OpenSSL syntax that contains the currently defined list of TLS 1.0-1.2 ciphersuites.
void | getListOfTLS13CipherSuitesForOpenSSL (OFString &cslist, OFBool isServer) const
| returns a string in OpenSSL syntax that contains the currently defined list of TLS 1.3 ciphersuites.
long | getTLSOptions () const
| returns the set of flags that need to be activated in OpenSSL depending on the selected TLS profile.
OFBool | cipher3DESsupported () const
| checks if the 3DES ciphersuite TLS_RSA_WITH_3DES_EDE_CBC_SHA is supported by the underlying OpenSSL library (which newer versions only do if compiled with "weak ciphers" enabled).
OFBool | cipherNULLsupported () const
| checks if the unencrypted ciphersuite TLS_RSA_WITH_NULL_SHA is supported by the underlying OpenSSL library (which newer versions only do if compiled with "weak ciphers" enabled).
OFBool | isTLS13Enabled () const
| checks if TLS 1.3 is enabled (permitted) for the currently selected TLS security profile.
void | printSupportedCiphersuites (STD_NAMESPACE ostream &os) const
| print a list of supported TLS 1.0-1.2 ciphersuites to the given output stream
void | printSupportedTLS13Ciphersuites (STD_NAMESPACE ostream &os) const
| print a list of supported TLS 1.3 ciphersuites to the given output stream
void | printSupportedTLSProfiles (STD_NAMESPACE ostream &os) const
| print a list of supported TLS profiles to the given output stream

## Static Public Member Functions

static size_t | getNumberOfCipherSuites ()
| returns the number of known TLS 1.0-1.2 ciphersuites.
static size_t | getNumberOfTLS13CipherSuites ()
| returns the number of known TLS 1.3 ciphersuites.
static size_t | lookupCiphersuite (const char *tlsCipherSuiteName)
| looks up the index of the given TLS 1.0-1.2 ciphersuite by name
static size_t | lookupTLS13Ciphersuite (const char *tlsCipherSuiteName)
| looks up the index of the given TLS 1.3 ciphersuite by name
static size_t | lookupCiphersuiteByOpenSSLName (const char *opensslCipherSuiteName)
| looks up the index of the given TLS 1.0-1.2 ciphersuite by OpenSSL name
static size_t | lookupTLS13CiphersuiteByOpenSSLName (const char *opensslCipherSuiteName)
| looks up the index of the given TLS 1.3 ciphersuite by OpenSSL name
static const char * | getTLSCipherSuiteName (size_t idx)
| returns a TLS 1.0-1.2 ciphersuite name in RFC 2246 (TLS) form
static const char * | getTLS13CipherSuiteName (size_t idx)
| returns a TLS 1.3 ciphersuite name in RFC 2246 (TLS) form
static const char * | getOpenSSLCipherSuiteName (size_t idx)
| returns a TLS 1.0-1.2 ciphersuite name in OpenSSL form
static const char * | getOpenSSLTLS13CipherSuiteName (size_t idx)
| returns a TLS 1.3 ciphersuite name in OpenSSL form
static DcmTLSCipherProtocolVersion | getCipherSuiteProtocolVersion (size_t idx)
| returns the minimum SSL/TLS version required for the TLS 1.0-1.2 ciphersuite with the given index
static DcmTLSCipherProtocolVersion | getTLS13CipherSuiteProtocolVersion (size_t idx)
| returns the minimum SSL/TLS version required for the TLS 1.3 ciphersuite with the given index
static DcmTLSCipherKeyExchange | getCipherSuiteKeyExchange (size_t idx)
| returns the key exchange protocol used by the TLS 1.0-1.2 ciphersuite with the given index
static DcmTLSCipherKeyExchange | getTLS13CipherSuiteKeyExchange (size_t idx)
| returns the key exchange protocol used by the TLS 1.3 ciphersuite with the given index
static DcmTLSCipherAuthentication | getCipherSuiteAuthentication (size_t idx)
| returns the authentication algorithm used by the TLS 1.0-1.2 ciphersuite with the given index
static DcmTLSCipherAuthentication | getTLS13CipherSuiteAuthentication (size_t idx)
| returns the authentication algorithm used by the TLS 1.3 ciphersuite with the given index
static DcmTLSCipherEncryption | getCipherSuiteEncryption (size_t idx)
| returns the encryption algorithm used by the TLS 1.0-1.2 ciphersuite with the given index
static DcmTLSCipherEncryption | getTLS13CipherSuiteEncryption (size_t idx)
| returns the encryption algorithm used by the TLS 1.3 ciphersuite with the given index
static DcmTLSCipherMAC | getCipherSuiteMAC (size_t idx)
| returns the message authentication code (MAC) algorithm used by the TLS 1.0-1.2 ciphersuite with the given index
static DcmTLSCipherMAC | getTLS13CipherSuiteMAC (size_t idx)
| returns the message authentication code (MAC) algorithm used by the TLS 1.3 ciphersuite with the given index
static DcmTLSCipherMode | getCipherSuiteMode (size_t idx)
| returns the mode of operation used by the TLS 1.0-1.2 ciphersuite with the given index
static DcmTLSCipherMode | getTLS13CipherSuiteMode (size_t idx)
| returns the mode of operation used by the TLS 1.3 ciphersuite with the given index
static size_t | getCipherSuiteKeySize (size_t idx)
| returns the symmetric key size used by the TLS 1.0-1.2 ciphersuite with the given index
static size_t | getTLS13CipherSuiteKeySize (size_t idx)
| returns the symmetric key size used by the TLS 1.3 ciphersuite with the given index
static size_t | getCipherSuiteEffectiveKeySize (size_t idx)
| returns the effective symmetric key size (i.e.
static size_t | getTLS13CipherSuiteEffectiveKeySize (size_t idx)
| returns the effective symmetric key size (i.e.
static const char * | lookupProfileName (DcmTLSSecurityProfile profile)
| look up the name of the given security profile

## Static Public Attributes

static const size_t | unknownCipherSuiteIndex
| constant returned by findOpenSSLCipherSuiteName() if ciphersuite name is unknown

## Private Member Functions

| DcmTLSCiphersuiteHandler (const DcmTLSCiphersuiteHandler &)
| private undefined copy constructor
DcmTLSCiphersuiteHandler & | operator= (const DcmTLSCiphersuiteHandler &)
| private undefined assignment operator
void | determineSupportedCiphers ()
| determine the set of TLS 1.0-1.2 ciphersuites that are supported both by DCMTK and the OpenSSL library we are currently using
OFCondition | addRequiredCipherSuite (const char *name)
| add TLS 1.0-1.2 ciphersuite by name, print error if unsupported
OFCondition | addRequiredTLS13CipherSuite (const char *name)
| add TLS 1.3 ciphersuite by name, print error if unsupported
void | addOptional3DESCipherSuite ()
| add 3DES ciphersuite, print warning if unsupported

## Private Attributes

OFVector< size_t > | ciphersuiteList
| current list of ciphersuites for TLS 1.0-1.2
OFVector< size_t > | tls13ciphersuiteList
| current list of ciphersuites for TLS 1.3
DcmTLSSecurityProfile | currentProfile
| currently selected DICOM TLS security profile
OFBool | tls13_enabled
| indicator whether TLS 1.3 is enabled or disabled for the current profile
OFBool * | ciphersuiteSupported
| an array of booleans indicating which ciphersuites known to DCMTK are actually supported by the OpenSSL library we are using.

## Detailed Description

This helper class manages the list of TLS ciphersuites supported by DCMTK, translates DcmTLSSecurityProfile enums into the corresponding sets of ciphersuites, and permits translation between the official TLS ciphersuite names (as used in DCMTK) and the corresponding internal OpenSSL name.

Remarks
  This class is only available if DCMTK is compiled with OpenSSL support enabled.

## Constructor & Destructor Documentation

## DcmTLSCiphersuiteHandler()

DcmTLSCiphersuiteHandler::DcmTLSCiphersuiteHandler | ( |  | ) |

constructor.

The constructor assumes that the OpenSSL library has already been initialized. This should be ensured prior to creating any DcmTLSCiphersuiteHandler instance by calling DcmTLSTransportLayer::initializeOpenSSL(). This only needs to be done once.

Referenced by DcmTLSCiphersuiteHandler(), and operator=().

## Member Function Documentation

## addCipherSuite()

OFCondition DcmTLSCiphersuiteHandler::addCipherSuite | ( | const char * | suite | ) |

adds a TLS 1.0-1.2 ciphersuite to the list of ciphersuites for TLS negotiation.

It is the responsibility of the user to ensure that the added ciphersuite does not break the rules of the selected profile. Use with care!

Parameters

  suite | TLS ciphersuite name, in the official TLS name form.

Returns
  EC_Normal if successful, an error code otherwise

## addRequiredCipherSuite()

OFCondition DcmTLSCiphersuiteHandler::addRequiredCipherSuite | ( | const char * | name | ) |

private

add TLS 1.0-1.2 ciphersuite by name, print error if unsupported

Parameters

  name | ciphersuite name in RFC 2246 form

Returns
  EC_Normal if successful, an error code otherwise

## addRequiredTLS13CipherSuite()

OFCondition DcmTLSCiphersuiteHandler::addRequiredTLS13CipherSuite | ( | const char * | name | ) |

private

add TLS 1.3 ciphersuite by name, print error if unsupported

Parameters

  name | ciphersuite name in RFC 2246 form

Returns
  EC_Normal if successful, an error code otherwise

## cipher3DESsupported()

OFBool DcmTLSCiphersuiteHandler::cipher3DESsupported | ( |  | ) | const

checks if the 3DES ciphersuite TLS_RSA_WITH_3DES_EDE_CBC_SHA is supported by the underlying OpenSSL library (which newer versions only do if compiled with "weak ciphers" enabled).

Returns
  true if we support 3DES, false otherwise

## cipherNULLsupported()

OFBool DcmTLSCiphersuiteHandler::cipherNULLsupported | ( |  | ) | const

checks if the unencrypted ciphersuite TLS_RSA_WITH_NULL_SHA is supported by the underlying OpenSSL library (which newer versions only do if compiled with "weak ciphers" enabled).

Returns
  true if we support unencrypted TLS, false otherwise

## clearTLSProfile()

void DcmTLSCiphersuiteHandler::clearTLSProfile | ( |  | ) |

clear the current list of ciphersuites.

Equivalent to calling setTLSProfile(TSP_Profile_None).

## getCipherSuiteAuthentication()

DcmTLSCipherAuthentication DcmTLSCiphersuiteHandler::getCipherSuiteAuthentication | ( | size_t | idx | ) |

static

returns the authentication algorithm used by the TLS 1.0-1.2 ciphersuite with the given index

Parameters

  idx | index, must be < getNumberOfCipherSuites()

Returns
  authentication algorithm

## getCipherSuiteEffectiveKeySize()

size_t DcmTLSCiphersuiteHandler::getCipherSuiteEffectiveKeySize | ( | size_t | idx | ) |

static

returns the effective symmetric key size (i.e.

security level) of the TLS 1.0-1.2 ciphersuite with the given index. BCP 195 (2015) recommends that no ciphersuites with an effective key size of less than 112 bits should be used anymore with TLS.

Parameters

  idx | index, must be < getNumberOfCipherSuites()

Returns
  effective symmetric key size, in bits

## getCipherSuiteEncryption()

DcmTLSCipherEncryption DcmTLSCiphersuiteHandler::getCipherSuiteEncryption | ( | size_t | idx | ) |

static

returns the encryption algorithm used by the TLS 1.0-1.2 ciphersuite with the given index

Parameters

  idx | index, must be < getNumberOfCipherSuites()

Returns
  minimum SSL/TLS version required

## getCipherSuiteKeyExchange()

DcmTLSCipherKeyExchange DcmTLSCiphersuiteHandler::getCipherSuiteKeyExchange | ( | size_t | idx | ) |

static

returns the key exchange protocol used by the TLS 1.0-1.2 ciphersuite with the given index

Parameters

  idx | index, must be < getNumberOfCipherSuites()

Returns
  key exchange protocol

## getCipherSuiteKeySize()

size_t DcmTLSCiphersuiteHandler::getCipherSuiteKeySize | ( | size_t | idx | ) |

static

returns the symmetric key size used by the TLS 1.0-1.2 ciphersuite with the given index

Parameters

  idx | index, must be < getNumberOfCipherSuites()

Returns
  symmetric key size, in bits

## getCipherSuiteMAC()

DcmTLSCipherMAC DcmTLSCiphersuiteHandler::getCipherSuiteMAC | ( | size_t | idx | ) |

static

returns the message authentication code (MAC) algorithm used by the TLS 1.0-1.2 ciphersuite with the given index

Parameters

  idx | index, must be < getNumberOfCipherSuites()

Returns
  message authentication code (MAC) algorithm

## getCipherSuiteMode()

DcmTLSCipherMode DcmTLSCiphersuiteHandler::getCipherSuiteMode | ( | size_t | idx | ) |

static

returns the mode of operation used by the TLS 1.0-1.2 ciphersuite with the given index

Parameters

  idx | index, must be < getNumberOfCipherSuites()

Returns
  mode of operation for block ciphers, TKM_NA otherwise

## getCipherSuiteProtocolVersion()

DcmTLSCipherProtocolVersion DcmTLSCiphersuiteHandler::getCipherSuiteProtocolVersion | ( | size_t | idx | ) |

static

returns the minimum SSL/TLS version required for the TLS 1.0-1.2 ciphersuite with the given index

Parameters

  idx | index, must be < getNumberOfCipherSuites()

Returns
  minimum SSL/TLS version required

## getListOfCipherSuitesForOpenSSL()

void DcmTLSCiphersuiteHandler::getListOfCipherSuitesForOpenSSL | ( | OFString & | cslist,
|  | OFBool | isServer ) const

returns a string in OpenSSL syntax that contains the currently defined list of TLS 1.0-1.2 ciphersuites.

Parameters

  cslist | The list of ciphersuites in OpenSSL syntax is written to this string.
  isServer | true if the list of cipher suites is intended for a TLS server. In this case, the list of ciphersuites will be reordered from strongest to weakest, as recommended by BCP 195.

## getListOfTLS13CipherSuitesForOpenSSL()

void DcmTLSCiphersuiteHandler::getListOfTLS13CipherSuitesForOpenSSL | ( | OFString & | cslist,
|  | OFBool | isServer ) const

returns a string in OpenSSL syntax that contains the currently defined list of TLS 1.3 ciphersuites.

Parameters

  cslist | The list of ciphersuites in OpenSSL syntax is written to this string.
  isServer | true if the list of cipher suites is intended for a TLS server. In this case, the list of ciphersuites will be reordered from strongest to weakest, as recommended by BCP 195.

## getNumberOfCipherSuites()

size_t DcmTLSCiphersuiteHandler::getNumberOfCipherSuites | ( |  | ) |

static

returns the number of known TLS 1.0-1.2 ciphersuites.

Returns
  number of known ciphersuites

## getNumberOfTLS13CipherSuites()

size_t DcmTLSCiphersuiteHandler::getNumberOfTLS13CipherSuites | ( |  | ) |

static

returns the number of known TLS 1.3 ciphersuites.

Returns
  number of known ciphersuites

## getOpenSSLCipherSuiteName()

const char * DcmTLSCiphersuiteHandler::getOpenSSLCipherSuiteName | ( | size_t | idx | ) |

static

returns a TLS 1.0-1.2 ciphersuite name in OpenSSL form

Parameters

  idx | index, must be < getNumberOfCipherSuites()

Returns
  ciphersuite name

## getOpenSSLTLS13CipherSuiteName()

const char * DcmTLSCiphersuiteHandler::getOpenSSLTLS13CipherSuiteName | ( | size_t | idx | ) |

static

returns a TLS 1.3 ciphersuite name in OpenSSL form

Parameters

  idx | index, must be < getNumberOfCipherSuites()

Returns
  ciphersuite name

## getTLS13CipherSuiteAuthentication()

DcmTLSCipherAuthentication DcmTLSCiphersuiteHandler::getTLS13CipherSuiteAuthentication | ( | size_t | idx | ) |

static

returns the authentication algorithm used by the TLS 1.3 ciphersuite with the given index

Parameters

  idx | index, must be < getNumberOfCipherSuites()

Returns
  authentication algorithm

## getTLS13CipherSuiteEffectiveKeySize()

size_t DcmTLSCiphersuiteHandler::getTLS13CipherSuiteEffectiveKeySize | ( | size_t | idx | ) |

static

returns the effective symmetric key size (i.e.

security level) of the TLS 1.3 ciphersuite with the given index. BCP 195 (2015) recommends that no ciphersuites with an effective key size of less than 112 bits should be used anymore with TLS.

Parameters

  idx | index, must be < getNumberOfCipherSuites()

Returns
  effective symmetric key size, in bits

## getTLS13CipherSuiteEncryption()

DcmTLSCipherEncryption DcmTLSCiphersuiteHandler::getTLS13CipherSuiteEncryption | ( | size_t | idx | ) |

static

returns the encryption algorithm used by the TLS 1.3 ciphersuite with the given index

Parameters

  idx | index, must be < getNumberOfCipherSuites()

Returns
  minimum SSL/TLS version required

## getTLS13CipherSuiteKeyExchange()

DcmTLSCipherKeyExchange DcmTLSCiphersuiteHandler::getTLS13CipherSuiteKeyExchange | ( | size_t | idx | ) |

static

returns the key exchange protocol used by the TLS 1.3 ciphersuite with the given index

Parameters

  idx | index, must be < getNumberOfCipherSuites()

Returns
  key exchange protocol

## getTLS13CipherSuiteKeySize()

size_t DcmTLSCiphersuiteHandler::getTLS13CipherSuiteKeySize | ( | size_t | idx | ) |

static

returns the symmetric key size used by the TLS 1.3 ciphersuite with the given index

Parameters

  idx | index, must be < getNumberOfCipherSuites()

Returns
  symmetric key size, in bits

## getTLS13CipherSuiteMAC()

DcmTLSCipherMAC DcmTLSCiphersuiteHandler::getTLS13CipherSuiteMAC | ( | size_t | idx | ) |

static

returns the message authentication code (MAC) algorithm used by the TLS 1.3 ciphersuite with the given index

Parameters

  idx | index, must be < getNumberOfCipherSuites()

Returns
  message authentication code (MAC) algorithm

## getTLS13CipherSuiteMode()

DcmTLSCipherMode DcmTLSCiphersuiteHandler::getTLS13CipherSuiteMode | ( | size_t | idx | ) |

static

returns the mode of operation used by the TLS 1.3 ciphersuite with the given index

Parameters

  idx | index, must be < getNumberOfCipherSuites()

Returns
  mode of operation for block ciphers, TKM_NA otherwise

## getTLS13CipherSuiteName()

const char * DcmTLSCiphersuiteHandler::getTLS13CipherSuiteName | ( | size_t | idx | ) |

static

returns a TLS 1.3 ciphersuite name in RFC 2246 (TLS) form

Parameters

  idx | index, must be < getNumberOfCipherSuites()

Returns
  ciphersuite name

## getTLS13CipherSuiteProtocolVersion()

DcmTLSCipherProtocolVersion DcmTLSCiphersuiteHandler::getTLS13CipherSuiteProtocolVersion | ( | size_t | idx | ) |

static

returns the minimum SSL/TLS version required for the TLS 1.3 ciphersuite with the given index

Parameters

  idx | index, must be < getNumberOfCipherSuites()

Returns
  minimum SSL/TLS version required

## getTLSCipherSuiteName()

const char * DcmTLSCiphersuiteHandler::getTLSCipherSuiteName | ( | size_t | idx | ) |

static

returns a TLS 1.0-1.2 ciphersuite name in RFC 2246 (TLS) form

Parameters

  idx | index, must be < getNumberOfCipherSuites()

Returns
  ciphersuite name

## getTLSOptions()

long DcmTLSCiphersuiteHandler::getTLSOptions | ( |  | ) | const

returns the set of flags that need to be activated in OpenSSL depending on the selected TLS profile.

Returns
  flags for openssl

## getTLSProfile()

DcmTLSSecurityProfile DcmTLSCiphersuiteHandler::getTLSProfile | ( |  | ) | const

inline

return the currently selected TLS profile

Returns
  currently selected TLS profile

References currentProfile.

## isTLS13Enabled()

OFBool DcmTLSCiphersuiteHandler::isTLS13Enabled | ( |  | ) | const

checks if TLS 1.3 is enabled (permitted) for the currently selected TLS security profile.

Note that this does not imply that the underlying OpenSSL library version actually supports TLS 1.3. That is checked elsewhere.

Returns
  true if we support TLS 1.3, false otherwise

## lookupCiphersuite()

size_t DcmTLSCiphersuiteHandler::lookupCiphersuite | ( | const char * | tlsCipherSuiteName | ) |

static

looks up the index of the given TLS 1.0-1.2 ciphersuite by name

Parameters

  tlsCipherSuiteName | ciphersuite name in RFC 2246 form

Returns
  index into list of ciphersuites, DcmTLSCiphersuiteHandler::unknownCipherSuiteIndex if ciphersuite unknown

## lookupCiphersuiteByOpenSSLName()

size_t DcmTLSCiphersuiteHandler::lookupCiphersuiteByOpenSSLName | ( | const char * | opensslCipherSuiteName | ) |

static

looks up the index of the given TLS 1.0-1.2 ciphersuite by OpenSSL name

Parameters

  opensslCipherSuiteName | ciphersuite name in the form used by OpenSSL

Returns
  index into list of ciphersuites, DcmTLSCiphersuiteHandler::unknownCipherSuiteIndex if ciphersuite unknown

## lookupProfileName()

const char * DcmTLSCiphersuiteHandler::lookupProfileName | ( | DcmTLSSecurityProfile | profile | ) |

static

look up the name of the given security profile

Parameters

  profile | the given security profile

Returns
  name of security profile, never NULL.

## lookupTLS13Ciphersuite()

size_t DcmTLSCiphersuiteHandler::lookupTLS13Ciphersuite | ( | const char * | tlsCipherSuiteName | ) |

static

looks up the index of the given TLS 1.3 ciphersuite by name

Parameters

  tlsCipherSuiteName | ciphersuite name in RFC 2246 form

Returns
  index into list of ciphersuites, DcmTLSCiphersuiteHandler::unknownCipherSuiteIndex if ciphersuite unknown

## lookupTLS13CiphersuiteByOpenSSLName()

size_t DcmTLSCiphersuiteHandler::lookupTLS13CiphersuiteByOpenSSLName | ( | const char * | opensslCipherSuiteName | ) |

static

looks up the index of the given TLS 1.3 ciphersuite by OpenSSL name

Parameters

  opensslCipherSuiteName | ciphersuite name in the form used by OpenSSL

Returns
  index into list of ciphersuites, DcmTLSCiphersuiteHandler::unknownCipherSuiteIndex if ciphersuite unknown

## printSupportedCiphersuites()

void DcmTLSCiphersuiteHandler::printSupportedCiphersuites | ( | STD_NAMESPACE ostream & | os | ) | const

print a list of supported TLS 1.0-1.2 ciphersuites to the given output stream

Parameters

  os | output stream

## printSupportedTLS13Ciphersuites()

void DcmTLSCiphersuiteHandler::printSupportedTLS13Ciphersuites | ( | STD_NAMESPACE ostream & | os | ) | const

print a list of supported TLS 1.3 ciphersuites to the given output stream

Parameters

  os | output stream

## printSupportedTLSProfiles()

void DcmTLSCiphersuiteHandler::printSupportedTLSProfiles | ( | STD_NAMESPACE ostream & | os | ) | const

print a list of supported TLS profiles to the given output stream

Parameters

  os | output stream

## setTLSProfile()

OFCondition DcmTLSCiphersuiteHandler::setTLSProfile | ( | DcmTLSSecurityProfile | profile | ) |

replace the current list of ciphersuites by the list of ciphersuites for the given profile.

Parameters

  profile | TLS Security Profile

Returns
  EC_Normal if successful, an error code otherwise

The documentation for this class was generated from the following file:

- dcmtls/include/dcmtk/dcmtls/tlsciphr.h

Generated on for DCMTK Version 3.7.0 by Doxygen 1.15.0